# Copyright {{ year }} Karlsruhe Institute of Technology
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
import subprocess
import sys

from xmlhelpy import argument
from xmlhelpy import option

from .main import {{ group }}


@{{ group }}.command()
{% for arg in args_dict[0:-2] -%}
  @option({% if arg["keyword"] %}"{{ arg["keyword"] }}", {% endif %}{% if arg["char"] %}char="{{ arg["char"] }}", {% endif %}description="{{ arg["description"] }}")
{% endfor -%}
def {{ command }}({{ args }}):
    """{{ description }}"""

    cmd = ["{{ command }}"]

    {% for arg in args_dict %}
      {%- if arg["char"] and arg["keyword"] -%}
        if {{ arg["keyword"][2:].replace("-", "_") }}:
        cmd += ["{{ arg["char"] }}"]
      {%- elif arg["keyword"] -%}
        if {{ arg["keyword"][2:].replace("-", "_") }}:
        cmd += ["{{ arg["keyword"] }}"]
      {%- else -%}
        if {{ arg["char"][1] }}:
        cmd += ["{{ arg["char"] }}"]
      {%- endif %}
    {% endfor %}

    # Do not write to stdout to keep output intact for piping.
    print(" ".join(cmd), file=sys.stderr)
    sys.exit(subprocess.call(cmd))
